#include	<corlib.h>
#include	<string.h>
#include	<sys_doslib.h>
#include	"nsn.h"
#include	"graph.h"
#include	"sub.h"


int	layfree()
{
	int	i, j;
	unsigned short	*max= NULL;

	j= -1;
	for( i= 0; i < LAYERMAX; i++ ){
		if( (int)(layer[i].buf) > (int)max ){
			j= i;
		}
	}
	if( (int)(pcmdata.adrs) > (int)max ){
		MFREE( (int)pcmdata.adrs );
		pcmdata.adrs= NULL;
		pcmdata.name[0]= NULL;
		return TRUE;
	}else if( j >= 0 ){
		MFREE( (int)layer[j].buf );
		layer[j].buf= NULL;
		return TRUE;
	}
	return FALSE;
}

static int	load( LAYER *lay, int mode )
{
	unsigned char	*ptr;

	if( !(ptr= strrchr( lay->name, '.' ) ) ){
		return FALSE;
	}
	ptr++;
	if( !stricmp( ptr, "pic" ) ){
		return LoadPIC( lay, mode );
	}else if( !stricmp( ptr, "jpg" ) ){
		return LoadJPEG( lay, mode );
	}else if( !stricmp( ptr, "glm" ) ){
		return LoadGLM( lay, mode );
	}else {
		return FALSE;
	}
}

int	compose( LAYER *lay, ClipClass *s1, ClipClass *c1 )
{
	ClipClass	s2;
	int	i;

	if( c1 ){
		vgclr( c1->x1, c1->y1, c1->x2, c1->y2, bgcolor, vgram );
	}
	for( i= 0; i < LAYERMAX; i++, lay++ ){
		if( lay->name[0] ){
			if( !(lay->buf) ){
				if( !load( lay, 0 ) )	return -5;
			}
			s2.x1= lay->x;
			s2.y1= lay->y;
			s2.x2= lay->x + lay->h - 1;
			s2.y2= lay->y + lay->v - 1;
			if( c1 && rect( &(lay->clip), c1, &s2 ) ){	/*  */
				gtrans( i, lay, vgram );
			}
			if( s1 && rect( &(lay->clip), s1, &s2 ) ){	/* `攻 */
				gtrans( i, lay, vgram );
			}
		}
	}
	return TRUE;
}

int	layman( int mode, int x, int y, int level, unsigned char *filename )
{
	ClipClass	s1, s2, s3= { 0, 0, 511, 511 }, c1;
	int	other= FALSE;
	int	clr= FALSE;

	if( filename ){
		other= stricmp( filename, layer[level].name );
	}

	if( !filename || other ){
		if( layer[level].buf ){
			MFREE( (int)(layer[level].buf) );
			layer[level].buf= NULL;
		}
		if( !level ){
			layer[0].name[0]= NULL;
			c1= s3;
			clr= TRUE;
		}else if( layer[level].name[0] ){
			layer[level].name[0]= NULL;
			s2.x1= layer[level].x;
			s2.y1= layer[level].y;
			s2.x2= layer[level].x + layer[level].h - 1;
			s2.y2= layer[level].y + layer[level].v - 1;

			if( rect( &c1, &s3, &s2 ) ){
				clr= TRUE;
			}
		}
	}

	if( filename ){
		if( other ){
			strcpy( layer[level].name, filename );
			if( !load( &(layer[level]), lessmem ) ){
				if( clr ){
					compose( layer, NULL, &c1 );
					gput( mode, vgram, &c1 );
				}
				return FALSE;
			}
		}
		layer[level].x= x;
		layer[level].y= y;
		s2.x1= x;
		s2.y1= y;
		s2.x2= x + layer[level].h - 1;
		s2.y2= y + layer[level].v - 1;

		if( rect( &s1, &s3, &s2 ) ){	/* `̈悪 */
			if( clr &&  rect2( &c1, &s1 ) ){
								/* ̈悪`̈Ɋ܂܂ */
				clr= FALSE;		/* Ȃ */
			}
			compose( layer, &s1, (clr)?(&c1):(NULL) );
			if( clr ){			/*  + ` */
				if( rect3( &s3, &c1, &s1 ) ){
								/* ̈ƕ`̈悪dȂĂ */
					gput( mode, vgram, &s3 );
				}else {			/* ̈ƕ`̈悪Ă */
					gput( mode, vgram, &c1 );
					gput( mode, vgram, &s1 );
				}
			}else {				/* `̂ */
				gput( mode, vgram, &s1 );
			}
			return TRUE;
		}
	}
	if( clr ){
		compose( layer, NULL, &c1 );
		gput( mode, vgram, &c1 );
	}

	return TRUE;
}

