#include	<corlib.h>
#include	<sys_doslib.h>
#include	"PICSLICE.H"
#include	"nsn.h"
#include	"graph.h"

extern int	OpenPIC( picsliceinfo*, char* );
extern int	DrawPIC( picsliceinfo* );
extern void	EndOfDraw( picsliceinfo* );

void	psierr( char *ext, int type )
{
	char *msg;
	switch( type ){
	case PICSLICE_EFORMAT:
		msg= "tH[}bgႢ܂";
		break;
	case PICSLICE_EREAD:
		msg= "[hG[";
		break;
	case PICSLICE_EOVERFLOW:
		msg= "I[o[t[܂";
		break;
	case PICSLICE_NOMEMORY:
		msg= "܂";
		break;
	case PICSLICE_EOPEN:
		msg= "I[vł܂";
		break;
	default:
		msg= "̃G[";
	}
	ConsoleOpen();
	ConsolePrintf( "nsn : %s %s \n", ext, msg );
}

int	LoadPIC( LAYER *lay, int mode )
{
	char	format[]= "PIC";
	picsliceinfo	psi;
	int	ret;

	lay->buf= 0;
	ret= OpenPIC( &psi, getfullname( lay->name ) );
	if( ret != PICSLICE_NORMAL ){
		psierr( format, ret );
		return FALSE;
	}

	lay->h= psi.width;
	lay->v= psi.height;
	if( mode ){
		EndOfDraw( &psi );
		return TRUE;
	}
	do{
		psi.chainbuf= MALLOC( psi.width * psi.height * 2 );
		if( (int)psi.chainbuf >= 0 )	break;
	} while( layfree() );
	if( (int)psi.chainbuf < 0 ){
		EndOfDraw( &psi );
		psierr( format, PICSLICE_NOMEMORY );
		return FALSE;
	}

	ret= DrawPIC( &psi );
	if( ret != PICSLICE_TERMINATE ){
		psierr( format, ret );
		MFREE( (int)psi.chainbuf );
		return FALSE;
	}
	lay->buf= psi.chainbuf;
	return TRUE;
}
