RUNS_HUMAN_VERSION	equ	3
	.include doscall.mac

	.text
	.even

READBIT1	macro
	local	nextbyte,thisbit

	dbra	d7,thisbit
	dbra	d6,nextbyte
	bsr	readData
	bra	thisbit
nextbyte
	addq.l	#2,(a0)
	moveq.l	#15,d7
thisbit
	moveq.l	#0,d0
	movea.l	(a0),a1
	lsl.w	(a1)
	scc	d0
	addq.b	#1,d0

	endm

READBITS	macro
	local	get,exist,check

	movea.l	(a0),a1
	moveq.l	#0,d1
	bra	check
get
	moveq.l	#0,d2
	move.w	d7,d0
	sub.w	d0,d3
	move.w	(a1),d2
	lsl.l	d0,d2
	move.w	d2,(a1)
	swap.w	d2
	lsl.l	d0,d1
	or.w	d2,d1
	dbra	d6,exist
	bsr	readData
	movea.l	(a0),a1
	moveq.l	#16,d7
	bra	check
exist
	addq.w	#2,a1
	moveq.l	#16,d7
check
	cmp.w	d7,d3
	bgt	get
	sub.w	d3,d7
	moveq.l	#0,d2
	move.w	(a1),d2
	lsl.l	d3,d2
	move.w	d2,(a1)
	swap.w	d2
	move.l	a1,(a0)
	lsl.l	d3,d1
	or.w	d2,d1
	move.l	d1,d0

	endm

READBIT7	macro
	local	nextbyte7,thisbit7

	movea.l	(a0),a1
	moveq.l	#0,d1
	cmp.w	d7,d2
	ble	thisbit7
	move.w	(a1),d1
	lsl.l	d7,d1
	sub.w	d7,d2
	dbra	d6,nextbyte7
	bsr	readData
	movea.l	(a0),a1
	moveq.l	#16,d7
	bra	thisbit7
nextbyte7
	addq.w	#2,a1
	move.l	a1,(a0)
	moveq.l	#16,d7
thisbit7
	sub.w	d2,d7
	move.w	(a1),d1
	lsl.l	d2,d1
	move.w	d1,(a1)
	clr.w	d1
	swap.w	d1
	move.l	d1,d0

	endm

	.globl	_OpenPIC
_OpenPIC:
	movem.l	d3/d4/d5/d6/d7/a3/a4/a5,-(sp)
	move.l	36(sp),a0	*psi
	movea.l	a0,a5		*psi

	moveq.l	#32,d0
	move.w	d0,-(sp)
	move.l	40+2(sp),-(sp)	*filename
	DOS	_OPEN
	addq.w	#6,sp
	tst.l	d0
	bpl	openok
	clr.l	(a0)
	moveq.l	#103,d0
	add.w	d0,d0
	bra	openerror
openok:
	move.l	d0,(a0)		*filehandle
	move.l	#16384,d0
	move.l	d0,8(a0)	*filebufsize
	move.l	d0,-(sp)
	moveq.l	#2,d0
	move.w	d0,-(sp)
	DOS	_MALLOC2
	addq.w	#6,sp
	tst.l	d0
	bgt	memoryok
	clr.l	4(a0)
	move.l	#205,d0		*PICSLICE_NOMEMORY
	bra	openerror
memoryok:
	move.l	d0,4(a0)	*filebuf
	lea.l	12(a0),a0	*currentbyte
	move.l	d0,(a0)		*currentbyte
	moveq.l	#0,d2
	move.l	d2,d6		*bytecount
	move.l	d2,d7		*bitcount
	move.w	d2,42(a0)	*freelist(_readerror)

	bsr	readchr		*init

	bsr	readchr
	cmp.b	#'P',d0
	bne	eformat
	bsr	readchr
	cmp.b	#'I',d0
	bne	eformat
	bsr	readchr
	cmp.b	#'C',d0
	bne	eformat
	moveq.l	#$1a,d2
comment_lp:
	bsr	readchr
	cmp.b	d0,d2
	bne	comment_lp
skip_lp:
	bsr	readchr
	tst.b	d0
	bne	skip_lp
	bsr	readchr
	tst.b	d0
	bne	eformat
	bsr	readchr
	tst.b	d0
	bne	eformat
	bsr	readchr
	tst.b	d0
	bne	eformat
	bsr	readchr
	moveq.l	#15,d2
	cmp.b	d0,d2
	beq	format_ok
eformat:
	moveq.l	#101,d0
	add.w	d0,d0		*PICSLICE_EFORMAT
	bra	openerror
format_ok:
	bsr	readchr
	lea.l	20(a5),a4	*width
	asl.l	#8,d0
	move.l	d0,(a4)
	bsr	readchr
	add.l	d0,(a4)+
	bsr	readchr
	asl.l	#8,d0
	move.l	d0,(a4)		*height
	bsr	readchr
	add.l	d0,(a4)

	move.l	-(a4),d1	*width
	add.w	d1,d1
	move.l	d1,-(a4)	*realwidth
	moveq.l	#0,d2
	move.l	d2,28(a5)
	move.w	d2,36(a5)
	move.l	d2,46(a5)	*y		34(a0)
	move.l	a5,a1

	moveq.l	#0,d1
	moveq.l	#127,d2
ctbl_init_lp:
	lea.l	(a1,d1.w),a2
	clr.w	66(a2)
	subq.w	#2,d1
	move.b	d1,323(a2)	*prev
	addq.w	#4,d1
	move.b	d1,322(a2)	*next
	dbra	d2,ctbl_init_lp

	clr.w	1346(a1)	*color
	moveq.l	#0,d3

firstlen_lp:
	addq.l	#1,d3
	READBIT1
	bne	firstlen_lp

	move.l	d3,-(sp)
	READBITS
	move.l	(sp)+,d3
	move.l	d0,a2
	moveq.l	#1,d0
	asl.l	d3,d0
	lea.l	-2(a2,d0.l),a2
	move.l	a2,32(a5)
	tst.w	54(a5)
	beq	normal

	move.l	#203,d0		*PICSLICE_EREAD
	bra	openerror
normal:
	move.w	d6,48(a0)	*bytecount
	move.w	d7,52(a0)	*bitcount
	moveq.l	#100,d0
	add.w	d0,d0		*PICSLICE_NORMAL
	bra	readok
openerror:
	move.l	d0,d7
	move.l	a5,-(sp)
	bsr	_EndOfDraw
	addq.w	#4,sp
	move.l	d7,d0
readok:
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3/a4/a5
	rts

	.even
readchr:
	moveq.l	#0,d0
	movea.l	(a0),a1
	move.w	(a1),d0
	subq.w	#8,d7
	ble	lowbyte
	move.w	d0,d1
	lsl.w	#8,d1
	move.w	d1,(a1)
	lsr.w	#8,d0
	rts
lowbyte:
	lsr.w	#8,d0
	dbra	d6,exist_word
	move.l	d0,d1
	bsr	readData
	move.l	d1,d0
	rts
exist_word:
	addq.l	#2,(a0)
	moveq.l	#16,d7
	rts

	.even
readData:
	move.l	-4(a0),-(sp)	*filebufsize
	move.l	-8(a0),-(sp)	*filebuf
	move.w	-10(a0),-(sp)	*filehandle
	DOS	_READ
	lea.l	10(sp),sp
	subq.w	#2,d0
	lsr.w	d0
	move.w	d0,d6		*bytecount
	bne	not_empty
	moveq.l	#1,d0
	move.w	d0,42(a0)
not_empty:
	move.l	-8(a0),(a0)	*currentbyte
	moveq.l	#15,d7		*bitcount
	rts

	.even

	.globl _DrawPIC
_DrawPIC:
	movem.l	d3/d4/d5/d6/d7/a3/a4/a5/a6,-(sp)
	move.l	40(sp),a3
	move.l	38(a3),50(a3)	*frame		38(a0)
	move.l	38(a3),-(sp)	*frame
	moveq.l	#-1,d0
	move.l	d0,-(sp)	*color=0
	move.l	24(a3),d0	*height
	subq.w	#1,d0
	move.l	d0,-(sp)
	move.l	20(a3),d0	*width
	subq.w	#1,d0
	move.l	d0,-(sp)
	clr.l	-(sp)
	clr.l	-(sp)
	bsr	_vgclr
	lea.l	24(sp),sp

	lea.l	12(a3),a0
	moveq.l	#0,d5
	move.w	d5,42(a0)	*_readerror
	move.l	d5,d7
	move.w	48(a0),d6	*bytecount
	move.w	52(a0),d7	*bitcount
	lea.l	24(a0),a1	*color
	move.w	18(a0),a3	*currenty
	movea.l	8(a0),a4	*width
	move.l	20(a0),a5	*runlength
	movea.l	4(a0),a6	*realwidth
	bra	not_end

top:
	move.l	a4,d0		*width
	sub.l	d5,d0
	sub.l	d0,a5		*runlength
	moveq.l	#0,d5
	movea.l	38(a0),a2	*frame
	move.w	10(a0),d1	*width
	move.w	(a1),d2
	bra	draw_lp_ent
draw_lp:
	move.w	(a2),d0		*frame
	ror.b	#1,d0		*ibit_check
	bpl	i_off
	add.b	d0,d0
	move.w	d0,d2
i_off:
	move.w	d2,(a2)+	*color->frame
draw_lp_ent:
	dbra	d1,draw_lp

	move.w	d2,(a1)		*color
	move.l	a2,38(a0)	*frame
	addq.w	#1,a3
	cmpa.w	14(a0),a3	*currenty
	bne	not_end
	move.l	#201,d0		*PICSLICE_TERMINATE
	bra	endop
not_end:
	move.l	d5,d0
	add.l	a5,d0		*runlength
	cmp.l	a4,d0		*width
	bge	top
	add.l	a5,d5		*runlength

*readColor
	moveq.l	#0,d3
	READBIT1
	bne	cache
	moveq.l	#15,d2
	READBIT7
	lea.l	1334(a0),a1	*current
	move.w	(a1),d1
	lea.l	-12(a0,d1.w),a2
	move.b	322(a2),d3
	move.w	d3,(a1)
	add.w	d0,d0
	move.w	d0,54(a0,d3.w)
	move.w	d0,d3
	bra	cwrite
cache:
	moveq.l	#7,d2
	READBIT7
	move.l	d0,d2
	add.w	d2,d2
	move.w	1334(a0),d1
	cmp.w	d1,d2
	beq	same
	lea.l	310(a0),a1	*prev
	lea.l	(a1,d2.w),a2
	move.b	(a2)+,d0	*prev[idx]
	move.b	(a2),d3		*next[idx]
	move.b	d1,(a2)		*cc->next[idx]
	move.b	d0,(a1,d3.w)	*prev[idx]->prev[next[idx]]
	move.b	d3,1(a1,d0.w)	*next[idx]->next[prev[idx]]
	move.b	(a1,d1.w),d0	*prev[cc]
	move.b	d0,-(a2)	*prev[cc]->prev[idx]
	move.b	d2,1(a1,d0.w)	*idx->next[prev[cc]]
	move.b	d2,(a1,d1.w)	*idx->prev[cc]

	move.w	d2,1334(a0)	*idx->current
same:
	move.w	54(a0,d2.w),d3	*color[idx]
cwrite:
	or.w	#1,d3
	tst.w	42(a0)
	bne	eread
	move.l	d5,d0
	add.w	d0,d0
	movea.l	38(a0),a2	*frame
	move.w	d3,(a2,d0.w)
	READBIT1
	beq	getlen

*expandChain
	move.l	d5,-(sp)
	move.w	14(a0),d4	*height
	sub.w	a3,d4		*currenty
	subq.w	#1,d4
	movea.l	38(a0),a2	*frame
nextchain:
	moveq.l	#2,d2
	READBIT7
	bne	chain
	READBIT1
	beq	chain_end
	READBIT1
	beq	chain
	moveq.l	#4,d0
chain:
	subq.w	#2,d0
	add.w	d0,d5
	adda.l	a6,a2		*frame += realwidth

	tst.w	d5
	blt	over
	cmp.w	10(a0),d5	*width
	bge	over
	dbra	d4,down		*height
over:
	addq.w	#4,sp
	bra	eread

down:
	move.w	d5,d0
	add.w	d0,d0
	move.w	d3,(a2,d0.w)
	bra	nextchain

chain_end:
	move.l	(sp)+,d5

getlen:
	moveq.l	#0,d3
getlen_lp:
	addq.w	#1,d3
	READBIT1
	bne	getlen_lp

	movea.l	d3,a2
	READBITS
	move.l	a2,d3
	movea.l	d0,a2
	moveq.l	#1,d0
	asl.l	d3,d0
	lea.l	-1(a2,d0.l),a5	*runlength
	lea.l	24(a0),a1	*color
	tst.w	42(a0)
	beq	not_end
eread:
	move.l	#203,d0		*PICSLICE_EREAD
endop:
	move.l	d0,d7
	move.l	40(sp),-(sp)
	bsr	_EndOfDraw
	addq.w	#4,sp
	move.l	d7,d0
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3/a4/a5/a6
	rts

	.globl _EndOfDraw
	.even
_EndOfDraw:
	movea.l	4(sp),a1	*psi
	moveq.l	#0,d1
	move.l	(a1),d0		*filehandle
	beq	nofilehandle
	move.w	d0,-(sp)
	DOS	_CLOSE
	move.l	d1,(a1)
	addq.w	#2,sp
nofilehandle:
	move.l	4(a1),d0	*filebuf
	beq	nofilebuf
	move.l	d0,-(sp)
	DOS	_MFREE
	move.l	d1,4(a1)
	addq.w	#4,sp
nofilebuf:
	rts

	.globl _vgclr
	.even
_vgclr:				*virtual gram clr
	movem.l	d3-d7/a3-a4,-(sp)
	movem.l	32(sp),d0-d4/a0	*x0, y0, x1, y1, color, buf

	addq.w	#1,d2
	move.l	d2,d6
	sub.w	d0,d2		*h

	tst.l	d4
	bmi	pic1
	move.l	d3,d0
	swap.w	d0
	lsr.l	#7,d0
	bra	notpic1
pic1:
	move.l	d2,d0
	mulu	d3,d0
notpic1:
	add.l	d6,d0
	add.l	d0,d0
	adda.l	d0,a0		*buf

	tst.l	d4
	bmi	pic2

	move.l	#512,d0
	sub.w	d2,d0
	add.w	d0,d0
	movea.l	d0,a4		*add
	bra	notpic2
pic2:
	moveq.l	#0,d4
	suba.l	a4,a4
notpic2:

	sub.w	d1,d3
	addq.w	#1,d3		*v

	move.l	d2,d0		*xlpct
	lsr.l	#7,d0		*xlpct / 128
	swap.w	d0
	move.w	d2,d0
	and.w	#$7f,d0		*xlpct % 128

	move.l	d3,d2		*ylpct
	move.w	d4,d3		*color
	swap.w	d3
	move.w	d4,d3

	move.l	d3,d4
	move.l	d3,d5
	move.l	d3,d6
	move.l	d3,d7
	movea.l	d3,a1
	movea.l	d3,a2
	movea.l	d3,a3

	bra	clrylpent

clrylp:
	move.l	d0,d1
	bra	clrlp2ent

clrlp2:
	move.w	d3,-(a0)
clrlp2ent:
	dbra	d1,clrlp2
	swap.w	d1
	bra	clrxlpent

clrlp:
	rept	8

	movem.l	d3-d7/a1-a3,-(a0)

	endm

clrxlpent:
	dbra	d1,clrlp
	suba.l	a4,a0

clrylpent:
	dbra	d2,clrylp

	movem.l	(sp)+,d3-d7/a3-a4
	rts

	.even
	.end

