#include	<corlib.h>
#include	<string.h>
#include	"nsn.h"
#include	"sub.h"

int	setvar( unsigned char *name, int data )
{
	int flag= FALSE;
	int	i;

	for( i= 0; i < VARMAX; i++ ){
		if( !strcmp( vartbl[i].name, name ) ){
			flag= TRUE;
			break;
		}
	}
	if( !flag && data ){
		for( i= 0; i < VARMAX; i++ ){
			if( !(vartbl[i].name[0]) ){
				strcpy( vartbl[i].name, name );
				flag= TRUE;
				break;
			}
		}
	}
	if( flag ){
		if( data ){
			vartbl[i].data= data;

			if( debug ){
				ConsoleOpen();
				ConsolePrintf( "var[%s] = %d\n", vartbl[i].name, vartbl[i].data );
			}

		}else {
			vartbl[i].name[0]= NULL;
		}
		return TRUE;
	}else if( !data ){
		return TRUE;
	}else {
		return FALSE;
	}
}

char *getvar( unsigned char *name, int *var )
{
	char	varname[20];
	char	*wptr= varname;
	char	*ptr= name;
	int flag= FALSE;
	int	i;

	while( *ptr != 0x1a && *ptr != ';' && *ptr != ' ' ){
		*wptr++= *ptr++;
	}
	*wptr= NULL;
	

	for( i= 0; i < VARMAX; i++ ){
		if( !strcmp( vartbl[i].name, varname ) ){
			flag= TRUE;
			break;
		}
	}
	if( flag ){
		*var= vartbl[i].data;
	}else {
		*var= 0;
	}
	return ptr;
}

static void	skipspace( TBOX *tb )
{
	while( *(tb->ptr) == ' ' )	tb->ptr++;
}

static void	skipsection( TBOX *tb, int depth )
{
	int	current= depth;

	while( *(tb->ptr) != 0x1a ){
		if( *(tb->ptr ) == '}' ){
			if( --current < depth )	break;
		}else if( *(tb->ptr ) == '{' ){
			current++;
		}
		tb->ptr++;
	}
	if( *(tb->ptr) != 0x1a ){
		tb->ptr++;
	}
}

int	ifthen( TBOX *tb )
{
	int	cond;
	int	depth= 0;
	char	*ptr;

	while( 1 ) {
		if( !expr( tb, &cond ) && debug ){
				return -4;
		}
		skipspace( tb );
		if( *(tb->ptr) != '{' )	return -5;
		depth++;
		tb->ptr++;

/*
		if( debug ){
			ConsoleOpen();
			ConsolePrint( "section\n" );
		}
*/
		if( cond ){
			ptr= getparam( tb );
			if( !strcmpi( ptr, "GOTO" ) ){
				return gotolabel( tb );
			}else if( !strcmpi( ptr, "IF" ) ){
				continue;
			}
			if( !debug )	skipsection( tb, depth );
			return -5;
		}
		skipsection( tb, depth );

		if( *(tb->ptr) == 0x1a ){
			return -5;
		}

		ptr= getparam( tb );
		if( !strcmpi( ptr, "ELSE" ) ){
			skipspace( tb );
			if( *(tb->ptr) != '{' )	return -5;
			tb->ptr++;
			ptr= getparam( tb );
			if( !strcmpi( ptr, "GOTO" ) ){
				return gotolabel( tb );
			}else if( !strcmpi( ptr, "IF" ) ){
				continue;
			}
			if( !debug )	skipsection( tb, depth );
			return -5;
		}else if( strcmpi( ptr, "ELSEIF" ) ){
			if( !debug )	skipsection( tb, depth );
			return -5;
		}
		depth--;
	}
}
